<template>
  <EasyDataTable
    :empty-message="t('global.table.noData')"
    :headers="headers"
    :hide-rows-per-page="true"
    :items="items"
    :hide-footer="isSoloItem"
    :rows-of-page-separator-message="t('global.table.of')"
    :rows-per-page="isSoloItem ? 1 : 10"
    :table-min-height="0"
    alternating
    buttons-pagination
    header-item-class-name="vue3-easy-data-table__header-item"
    theme-color="#00ADEE"
  >
    <template #item-actions="item">
      <p v-if="item && item.actions" class="vue3-easy-data-table__actions">
        <router-link
          v-if="item.actions.view"
          v-tippy="t(`global.actions.view`)"
          :to="item.actions.view"
          class="vue3-easy-data-table__action"
        >
          <IconView class="icon icon--black" />
        </router-link>

        <router-link
          v-if="item.actions.update"
          v-tippy="t(`global.actions.update`)"
          :to="item.actions.update"
          class="vue3-easy-data-table__action"
        >
          <IconEdit class="icon icon--black" />
        </router-link>
        <button
          v-if="item.actions.external"
          v-tippy="t(`global.actions.external`)"
          :to="item.actions.external"
          class="vue3-easy-data-table__action"
          @click="handleExternal(item)"
        >
          <IconExternal class="icon icon--black" />
        </button>
        <button
          v-if="item.actions.delete"
          v-tippy="t(`global.actions.delete`)"
          class="vue3-easy-data-table__action red-bg"
          type="button"
          @click="handleDelete(item)"
        >
          <IconDelete class="icon icon--black" />
        </button>
      </p>
    </template>
  </EasyDataTable>
</template>
<style>
/* Style empty cells with red color */
.vue3-easy-data-table__body tr td:empty {
  background-color: lightcoral;
  border: 1px solid gray;
}
</style>

<script lang="ts" setup>
import type { FilterOption, Header, Item } from "vue3-easy-data-table";
import { useI18n } from "vue3-i18n";
import IconEdit from "@/assets/icons/icon__edit.svg";
import IconDelete from "@/assets/icons/icon__delete.svg";
import IconView from "@/assets/icons/icon__view.svg";
import IconExternal from "@/assets/icons/icon__external.svg";
const { t } = useI18n();

// eslint-disable-next-line
defineProps<{
  headers: Header[];
  items: Item[];
  isSoloItem?: boolean;
}>();

// eslint-disable-next-line
const emit = defineEmits<{
  (event: "delete", item: any): void;
  (event: "external", item: any): void;
}>();

function handleDelete(item: any) {
  emit("delete", item);
}
function handleExternal(item: any) {
  emit("external", item);
}
</script>
